import os
import sys

import pytest

from pathlib import Path
from rdflib import plugin, Graph, Literal, URIRef
from rdflib import RDF, FOAF, XSD
from rdflib.store import Store, NO_STORE, VALID_STORE

from ejerico.plugin.store.persistent_store import PersistentStore

class TestSetup:
    def __init__(self):
        self.a = random.randint(0, 10)


@pytest.fixture()
def register_plugin():
	print("ASf")
    
	
def test_helloworld():
	#assert True,"impossible is nothing"
	
	entry_points = (
		"rdf.plugins.store",
		"rdf.plugins.serializer",
		"rdf.plugins.parser",
		"rdf.plugins.resultparser",
		"rdf.plugins.resultserializer",
		"rdf.plugins.queryprocessor",
		"rdf.plugins.queryresult",
		"rdf.plugins.updateprocessor",
	)

	try:
		from pkg_resources import iter_entry_points
	except ImportError:
		print("Failed to import package 'pkg_resources'")
	else:
		for entry_point in entry_points:
			for ep in iter_entry_points(entry_point):
				print("Found {}".format(ep))

def z_test_register_plugin():
	my_identifier = URIRef("rdflib_persistent_store_test")
	store = plugin.get("ejerico_default_persistence", Store)(identifier=my_identifier)
	
	assert None != store, "failed to get plugin ({})".format()

def z_test_sqlite_open():
	my_home = str(Path.home())
	my_data_path = "{}{}.ejerico/store{}".format(my_home, os.sep, os.sep)
	
	os.makedirs(my_data_path, exist_ok=True)
	
	my_db_str = "sqlite:///{}rdflib_persistent_store.db".format(my_data_path)
	my_db_uri = Literal(my_db_str)
	my_identifier = URIRef("rdflib_persistent_store_test")

	my_graph = Graph(store="ejerico_default_persistence", identifier=my_identifier)
	
	status = None#g.open(my_uri, create=True)
	
	assert status == VALID_STORE, "Failed to open store ({})".format(my_db_str) 